#!/bin/sh

export QMAKESPEC=macx-g++

cd qmp
make && cp -R QMPlay.app ../ && rm -rf QMPlay.app

cd ..

mkdir QMPlay.app/Contents/Resources
mkdir QMPlay.app/Contents/MacOS/colors
mkdir QMPlay.app/Contents/MacOS/lang
mkdir QMPlay.app/Contents/MacOS/styles
mkdir QMPlay.app/Contents/MacOS/plugins
mkdir QMPlay.app/Contents/MacOS/lib

cp qmp/colors/*.qmpcolor QMPlay.app/Contents/MacOS/colors
cp qmp/lang/*.qmplang QMPlay.app/Contents/MacOS/lang
cp qmp/ChangeLog_QMPlay.txt QMPlay.app/Contents/MacOS
cp qmp/MacOS/*.icns QMPlay.app/Contents/Resources
cp qmp/MacOS/QMPlay.plist QMPlay.app/Contents/Info.plist
cp COPYING QMPlay.app/Contents/MacOS

cd qmp_curl
make && cp -R *.dylib ../QMPlay.app/Contents/MacOS/lib
cd ../qmp_export
make && cp -R *.dylib ../QMPlay.app/Contents/MacOS/lib
cd ../qmp_out
make && cp -R *.dylib ../QMPlay.app/Contents/MacOS/lib
cd ../qmp_lib
make && cp -R *.dylib ../QMPlay.app/Contents/MacOS/lib
cd ../qmp_equalizer
make && cp -R *.dylib ../QMPlay.app/Contents/MacOS/lib
cd ../plugins/playlists
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../openal
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../cdda
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../portaudio
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../effect_tst
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../effect_resample
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../func_rec
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../func_tag_editor
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../func_music_browser
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../mikmod
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../modplug
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../ogg
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../aac
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../mp3
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../vis_tst
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../vis_fft
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../vis_xmms_opengl_spectrum
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../raw
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../sndfile
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../snd_generator
make && cp -R *1.0.0.dylib ../../QMPlay.app/Contents/MacOS/plugins
cd ../../

cd other/QtCurve/style
make && cp *1.0.0.dylib ../../../QMPlay.app/Contents/MacOS/styles/qtcurve.dylib
cd ../../../
