#include <shlwapi.h>

const char FileExts[] = { "Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\FileExts\\" };
const char txt[] = { "Nie udało się uzyskac pełnego dostępu do rejestru!\nPrawdopodobnie nie masz uprawnień..." };

extern "C" char *doAssociate(char **extsAdd, int extsAddCount, char **extsDel, int extsDelCount, const char *qmpExecPath, bool onRun)
{
	{
		HKEY TSTREG;
		bool n(0),c(0),d(0);
		SHDeleteKey(HKEY_CURRENT_USER,"Software\\Classes\\REG_ACCESS_TEST_QMPlay");
		n = RegCreateKey(HKEY_CURRENT_USER,"Software\\Classes\\REG_ACCESS_TEST_QMPlay",&TSTREG);
		c = RegCloseKey(TSTREG);
		d = SHDeleteKey(HKEY_CURRENT_USER,"Software\\Classes\\REG_ACCESS_TEST_QMPlay");

		if ( n || d || c )
		{
			char *txt2 = new char[ strlen(txt) + 1 ];
			strcpy( txt2, txt );
			return txt2;
		}

		//żeby usunąć śmieci po starszej wersji tej biblioteki
		SHDeleteKey(HKEY_LOCAL_MACHINE,"Software\\Classes\\QMP");
		SHDeleteKey(HKEY_LOCAL_MACHINE,"Software\\Classes\\Drive\\shell\\QMP");
		SHDeleteKey(HKEY_LOCAL_MACHINE,"Software\\Classes\\Directory\\shell\\QMP");

		//żeby zastosować nową nazwę (QMPlay) należy usunąć stare śmieci
		SHDeleteKey(HKEY_CURRENT_USER,"Software\\Classes\\QMP");
		SHDeleteKey(HKEY_CURRENT_USER,"Software\\Classes\\Drive\\shell\\QMP");
		SHDeleteKey(HKEY_CURRENT_USER,"Software\\Classes\\Directory\\shell\\QMP");
	}

	HKEY hreg;
	char *qmpPthToReg, *tmp, *result = new char[8192];
	result[0] = 0;

	int addDrive(0), addCatalog(0);
	for ( int i = 0 ; i < extsAddCount ; i++ )
	{
		if ( !strcmp(extsAdd[i],"._Catalog") )
			addCatalog = 1;
		if ( !strcmp(extsAdd[i],"._Drive") )
			addDrive = 1;
	}
	for ( int i = 0 ; i < extsDelCount ; i++ )
	{
		if ( !strcmp(extsDel[i],"._Catalog") )
			addCatalog = -1;
		if ( !strcmp(extsDel[i],"._Drive") )
			addDrive = -1;
	}
	const char *QMPShellExt = { "Play in QMPlay" };
	if ( addCatalog == 1 )
	{
		SHDeleteKey(HKEY_CURRENT_USER,"Software\\Classes\\Directory\\shell\\QMPlay");
		RegCreateKey(HKEY_CURRENT_USER,"Software\\Classes\\Directory\\shell\\QMPlay",&hreg);
		RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)QMPShellExt,strlen(QMPShellExt) );
		RegCloseKey(hreg);
		RegCreateKey(HKEY_CURRENT_USER,"Software\\Classes\\Directory\\shell\\QMPlay\\command",&hreg);
		qmpPthToReg = new char[ strlen(qmpExecPath)+7+1 ];
		strcpy( qmpPthToReg, "\"" );
		strcat( qmpPthToReg, qmpExecPath );
		strcat( qmpPthToReg, "\" \"%1\"" );
		RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)qmpPthToReg,strlen(qmpPthToReg) );
		delete[] qmpPthToReg;
		RegCloseKey(hreg);
		strcat(result,"Dodano rozszerzenie menu kontekstowego katalogów\n");
	}
	else if ( addCatalog == -1 )
	{
		SHDeleteKey(HKEY_CURRENT_USER,"Software\\Classes\\Directory\\shell\\QMPlay");
		strcat(result,"Usunięto rozszerzenie menu kontekstowego katalogów\n");
	}
	if ( addDrive == 1 )
	{
		SHDeleteKey(HKEY_CURRENT_USER,"Software\\Classes\\Drive\\shell\\QMPlay");
		RegCreateKey(HKEY_CURRENT_USER,"Software\\Classes\\Drive\\shell\\QMPlay",&hreg);
		RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)QMPShellExt,strlen(QMPShellExt) );
		RegCloseKey(hreg);
		RegCreateKey(HKEY_CURRENT_USER,"Software\\Classes\\Drive\\shell\\QMPlay\\command",&hreg);
		qmpPthToReg = new char[ strlen(qmpExecPath)+5+1 ];
		strcpy( qmpPthToReg, "\"" );
		strcat( qmpPthToReg, qmpExecPath );
		strcat( qmpPthToReg, "\" %1" );
		RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)qmpPthToReg,strlen(qmpPthToReg) );
		delete[] qmpPthToReg;
		RegCloseKey(hreg);
		strcat(result,"Dodano rozszerzenie menu kontekstowego napędów\n");
	}
	else if ( addDrive == -1 )
	{
		SHDeleteKey(HKEY_CURRENT_USER,"Software\\Classes\\Drive\\shell\\QMPlay");
		strcat(result,"Usunięto rozszerzenie menu kontekstowego napędów\n");
	}
/**/
	SHDeleteKey(HKEY_CURRENT_USER,"Software\\Classes\\QMPlay");
	if ( extsAddCount > 0 )
	{
		RegCreateKey(HKEY_CURRENT_USER,"Software\\Classes\\QMPlay\\DefaultIcon",&hreg);
		qmpPthToReg = new char[ strlen(qmpExecPath)+2+1 ];
		strcpy( qmpPthToReg, qmpExecPath );
		strcat( qmpPthToReg, ",1" );
		RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)qmpPthToReg,strlen(qmpPthToReg) );
		delete[] qmpPthToReg;
		RegCloseKey(hreg);

		RegCreateKey(HKEY_CURRENT_USER,"Software\\Classes\\QMPlay\\Shell\\Open\\command",&hreg);
		qmpPthToReg = new char[ strlen(qmpExecPath)+7+1 ];
		strcpy( qmpPthToReg, "\"" );
		strcat( qmpPthToReg, qmpExecPath );
		strcat( qmpPthToReg, "\" \"%1\"" );
		RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)qmpPthToReg,strlen(qmpPthToReg) );
		delete[] qmpPthToReg;
		RegCloseKey(hreg);

		RegCreateKey(HKEY_CURRENT_USER,"Software\\Classes\\QMPlay\\Shell\\Enqueue in QMPlay\\command",&hreg);
		qmpPthToReg = new char[ strlen(qmpExecPath)+10+1 ];
		strcpy( qmpPthToReg, "\"" );
		strcat( qmpPthToReg, qmpExecPath );
		strcat( qmpPthToReg, "\" -a \"%1\"" );
		RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)qmpPthToReg,strlen(qmpPthToReg) );
		delete[] qmpPthToReg;
		RegCloseKey(hreg);

		RegCreateKey(HKEY_CURRENT_USER,"Software\\Classes\\QMPlay\\Shell\\Enqueue in QMPlay and play\\command",&hreg);
		qmpPthToReg = new char[ strlen(qmpExecPath)+11+1 ];
		strcpy( qmpPthToReg, "\"" );
		strcat( qmpPthToReg, qmpExecPath );
		strcat( qmpPthToReg, "\" -al \"%1\"" );
		RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)qmpPthToReg,strlen(qmpPthToReg) );
		delete[] qmpPthToReg;
		RegCloseKey(hreg);

		strcat(result,"Stworzono wpis \"QMPlay\" w rejestrze\n");
	}
	else
		strcat(result,"Usunięto wpis \"QMPlay\" w rejestrze\n");
/**/
	SHDeleteKey(HKEY_CURRENT_USER,"Software\\Classes\\QMPlayPlayList");
	if ( extsAddCount > 0 )
	{
		RegCreateKey(HKEY_CURRENT_USER,"Software\\Classes\\QMPlayPlayList\\DefaultIcon",&hreg);
		qmpPthToReg = new char[ strlen(qmpExecPath)+2+1 ];
		strcpy( qmpPthToReg, qmpExecPath );
		strcat( qmpPthToReg, ",2" );
		RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)qmpPthToReg,strlen(qmpPthToReg) );
		delete[] qmpPthToReg;
		RegCloseKey(hreg);

		RegCreateKey(HKEY_CURRENT_USER,"Software\\Classes\\QMPlayPlayList\\Shell\\Open\\command",&hreg);
		qmpPthToReg = new char[ strlen(qmpExecPath)+7+1 ];
		strcpy( qmpPthToReg, "\"" );
		strcat( qmpPthToReg, qmpExecPath );
		strcat( qmpPthToReg, "\" \"%1\"" );
		RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)qmpPthToReg,strlen(qmpPthToReg) );
		delete[] qmpPthToReg;
		RegCloseKey(hreg);

		RegCreateKey(HKEY_CURRENT_USER,"Software\\Classes\\QMPlayPlayList\\Shell\\Enqueue in QMPlay\\command",&hreg);
		qmpPthToReg = new char[ strlen(qmpExecPath)+10+1 ];
		strcpy( qmpPthToReg, "\"" );
		strcat( qmpPthToReg, qmpExecPath );
		strcat( qmpPthToReg, "\" -a \"%1\"" );
		RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)qmpPthToReg,strlen(qmpPthToReg) );
		delete[] qmpPthToReg;
		RegCloseKey(hreg);

		RegCreateKey(HKEY_CURRENT_USER,"Software\\Classes\\QMPlayPlayList\\Shell\\Enqueue in QMPlay and play\\command",&hreg);
		qmpPthToReg = new char[ strlen(qmpExecPath)+11+1 ];
		strcpy( qmpPthToReg, "\"" );
		strcat( qmpPthToReg, qmpExecPath );
		strcat( qmpPthToReg, "\" -al \"%1\"" );
		RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)qmpPthToReg,strlen(qmpPthToReg) );
		delete[] qmpPthToReg;
		RegCloseKey(hreg);

		strcat(result,"Stworzono wpis \"QMPlayPlayList\" w rejestrze\n");
	}
	else
		strcat(result,"Usunięto wpis \"QMPlayPlayList\" w rejestrze\n");
/**/
	int WOD(0);
	if ( addCatalog == -1 )
		WOD++;
	if ( addDrive == -1 )
		WOD++;
	if ( extsDelCount > WOD )
		strcat(result,"\nUsunięto rozszerzenia:\n");
	for ( int i = 0 ; i < extsDelCount ; i++ )
	{
		if ( !strcmp( extsDel[i], "._Catalog" ) || !strcmp( extsDel[i], "._Drive" ) )
			continue;

		tmp = new char[ strlen( FileExts ) + strlen( extsDel[i] ) + 1 ];
		strcpy( tmp, FileExts );
		strcat( tmp, extsDel[i] );
		SHDeleteKey(HKEY_CURRENT_USER,tmp);
		delete[] tmp;
		tmp = new char[ strlen( extsDel[i] ) + strlen( "Software\\Classes\\" ) + 1 ];
		strcpy( tmp, "Software\\Classes\\" );
		strcat( tmp, extsDel[i] );
		SHDeleteKey( HKEY_CURRENT_USER, tmp );
		SHDeleteKey( HKEY_LOCAL_MACHINE, tmp ); //żeby usunąć śmieci po starszej wersji tej biblioteki
		delete[] tmp;

		if ( i > 0 )
			strcat(result," ; ");
		strcat(result,extsDel[i]);
	}
	if ( extsDelCount > 0 )
		strcat(result,"\n");

	WOD = 0;
	if ( addCatalog == 1 )
		WOD++;
	if ( addDrive == 1 )
		WOD++;
	if ( extsAddCount > WOD )
		strcat(result,"\nDodano rozszerzenia:\n");
	for ( int i = 0 ; i < extsAddCount ; i++ )
	{
		if ( !strcmp( extsAdd[i], "._Catalog" ) || !strcmp( extsAdd[i], "._Drive" ) )
			continue;

		tmp = new char[ strlen( extsAdd[i] ) + strlen( "Software\\Classes\\" ) + 1 ];
		strcpy( tmp, "Software\\Classes\\" );
		strcat( tmp, extsAdd[i] );
		SHDeleteKey( HKEY_CURRENT_USER, tmp );
		SHDeleteKey( HKEY_LOCAL_MACHINE, tmp ); //żeby usunąć śmieci po starszej wersji tej biblioteki
		delete[] tmp;
		tmp = new char[ strlen( FileExts ) + strlen(extsAdd[i] ) + 1 ];
		strcpy( tmp, FileExts );
		strcat( tmp, extsAdd[i] );
		SHDeleteKey(HKEY_CURRENT_USER,tmp);
		delete[] tmp;
		tmp = new char[ strlen( extsAdd[i] ) + strlen( "Software\\Classes\\" ) + 1 ];
		strcpy( tmp, "Software\\Classes\\" );
		strcat( tmp, extsAdd[i] );
		RegCreateKey(HKEY_CURRENT_USER,tmp,&hreg);
		delete[] tmp;
		if ( !strcmp( extsAdd[i], ".qplst" ) || !strcmp( extsAdd[i], ".m3u" ) || !strcmp( extsAdd[i], ".pls" ) )
			RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)"QMPlayPlayList",14 );
		else
			RegSetValueEx( hreg,"",0,REG_SZ,(BYTE*)"QMPlay",6 );
		RegCloseKey(hreg);

		if ( i > 0 )
			strcat(result," ; ");
		strcat(result,extsAdd[i]);
	}

	if ( !onRun )
		return result;
	else
	{
		delete[] result;
		return 0;
	}
}
