void opcje(QWidget*)
{
}

void setSize( QSize s )
{
	QRect g;
	g.setX(0);
	g.setY(0);
	g.setHeight(s.height());
	g.setWidth(s.width());
	f1.setGeometry(g);
}

void Show(QWidget *w)
{
	if(w)
	{
		w->setMinimumSize( f1.minimumSize() );
		w->setMaximumSize( f1.maximumSize() );
		tmpWidget = w;
	}
	f1.setParent(tmpWidget);
	f1.move(0,0);
	f1.show();
}

void getOutLib(Qmp *_QLib)
{
	QLib = _QLib;
}

void Init()
{
	QMPConf = QLib->getFileName( QMP_CONF );
	YouTubeQualityList[0] << "MP4_HD_1080 (the highest quality)" << "MP4_HD (high quality)" << "MP4 (normal quality)" << "FLV_HD_480 (high quality)" << "FLV_HD_360 (high quality)" << "FLV (normal quality)";
	f1.Init();
}

void closePlug()
{
	f1.breakThr();
	f1.abortAll();
	f1.clrB();
	f1.setParent(NULL);
	f1.close();
}

void about(QWidget *w)
{
	QMessageBox::information(w,"QMPlay","Music Browser");
}

void setLang( QString langfile )
{
	Texts.clear();

	QMPset = new QSettings( langfile , QSettings::IniFormat );

	for ( int i = 0 ; i < langCount ; i++ )
		Texts += QString::fromUtf8( QMPset->value( "QMusicBrowserFunc/" + QString::number(i) ).toString().toAscii() );

	f1.ui.searchB->setText( Texts[ 22 ] /*Szukaj*/ );

	f1.ui.dwnPB->setText( QString::fromUtf8( QMPset->value( "QMusicBrowserFuncWindow/1" ).toString().toAscii() ) );
	f1.ui.clrB->setText( QString::fromUtf8( QMPset->value( "QMusicBrowserFuncWindow/2" ).toString().toAscii() ) );
	f1.ui.playB->setText( QString::fromUtf8( QMPset->value( "QMusicBrowserFuncWindow/3" ).toString().toAscii() ) );
	f1.ui.downloadB->setText( QString::fromUtf8( QMPset->value( "QMusicBrowserFuncWindow/4" ).toString().toAscii() ) );
	fl.ui.closeB->setText( QString::fromUtf8( QMPset->value( "QMusicBrowserFuncWindow/5" ).toString().toAscii() ) );
	fl.ui.defaultB->setText( QString::fromUtf8( QMPset->value( "QMusicBrowserFuncWindow/6" ).toString().toAscii() ) );
	fl.setWindowTitle( QString::fromUtf8( QMPset->value( "QMusicBrowserFuncWindow/7" ).toString().toAscii() ) );
	f1.ui.titlesW->horizontalHeaderItem(0)->setText( QString::fromUtf8( QMPset->value( "QMusicBrowserFuncWindow/8" ).toString().toAscii() ) );
	f1.ui.titlesW->horizontalHeaderItem(1)->setText( QString::fromUtf8( QMPset->value( "QMusicBrowserFuncWindow/9" ).toString().toAscii() ) );
	f1.ui.titlesW->horizontalHeaderItem(2)->setText( QString::fromUtf8( QMPset->value( "QMusicBrowserFuncWindow/10" ).toString().toAscii() ) );
	f1.ui.titlesW->horizontalHeaderItem(3)->setText( QString::fromUtf8( QMPset->value( "QMusicBrowserFuncWindow/11" ).toString().toAscii() ) );

	delete QMPset;
}
