void Save::odczytajopcje()
{
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("MMset/MMset").toBool() )
		{
			fsiposX = QMPset->value("MMset/fsiposX").toInt();
			fsiposY = QMPset->value("MMset/fsiposY").toInt();

			fmsW = QMPset->value("MMset/fmsW").toInt();
			fmsH = QMPset->value("MMset/fmsH").toInt();
			fsisW = QMPset->value("MMset/fsisW").toInt();
			fsisH = QMPset->value("MMset/fsisH").toInt();

			mdmixfreq = QMPset->value("MMset/mdmixfreq").toInt();
			interp = QMPset->value("MMset/interp").toBool();
			hqmixer = QMPset->value("MMset/hqmixer").toBool();
			surround = QMPset->value("MMset/surround").toBool();
			bits16 = QMPset->value("MMset/bits16").toBool();
			stereo = QMPset->value("MMset/stereo").toBool();
			reverse = QMPset->value("MMset/reverse").toBool();
			softmusic = QMPset->value("MMset/softmusic").toBool();
			softsndfx = QMPset->value("MMset/softsndfx").toBool();
			fadeout = QMPset->value("MMset/fadeout").toBool();
			loop = QMPset->value("MMset/loop").toBool();
			pansep = QMPset->value("MMset/pansep").toInt();
			reverb = QMPset->value("MMset/reverb").toInt();
			mdvolume = QMPset->value("MMset/mdvolume").toInt();
			chnMAX = QMPset->value("MMset/chnMAX").toInt();

			curF = QMPset->value("MMset/curF").toString();

			timRefValue = QMPset->value("MMset/timRefValue").toInt();

			savsek = QMPset->value("MMset/seek").toInt();
			savbpm = QMPset->value("MMset/bpm").toInt();
			savspd = QMPset->value("MMset/spd").toInt();

			formatSupport = QMPset->value("MMset/formatSupport").toString();
			Enabled = QMPset->value("MMset/Enabled").toBool();

			delete QMPset;

			if ( (timRefValue < 5) | (timRefValue > 999) )
				timRefValue=30;

			if (fsiposX < 0 )
				fsiposX=qdw.width()/2 - fsi.width()/2;
			if (fsiposY < 0 )
				fsiposY=qdw.height()/2 - fsi.height()/2;

			if (fsisW < 1 )
				fsisW = fsi.width();
			if (fsisH < 1 )
				fsisH =  fsi.height();

			if (mdmixfreq < 8000)
				mdmixfreq = 44100;

			loaded = true;
		}
	}

	if ( !loaded )
	{
		fsiposX=qdw.width()/2 - fsi.width()/2;
		fsiposY=qdw.height()/2 - fsi.height()/2;

		interp=true;
		stereo=true;
		bits16=true;

		chnMAX=64;
		mdmixfreq=44100;
		pansep=128;
		timRefValue=30;
		mdvolume=128;
		hqmixer = true;

		fmsW=fm->width();
		fmsH=fm->height();
		fsisW=fsi.width();
		fsisH=fsi.height();

		formatSupport = "669;amf;dsm;far;gdm;imf;med;m15;mtm;okt;stm;stx;ult;uni";

		Enabled = true;
	}
}

void Save::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("MMset/MMset",true);

	QMPset->setValue("MMset/fsiposX",fsiposX);
	QMPset->setValue("MMset/fsiposY",fsiposY);

	QMPset->setValue("MMset/fmsW",fmsW);
	QMPset->setValue("MMset/fmsH",fmsH);
	QMPset->setValue("MMset/fsisW",fsisW);
	QMPset->setValue("MMset/fsisH",fsisH);

	QMPset->setValue("MMset/mdmixfreq", mdmixfreq);
	QMPset->setValue("MMset/pansep", pansep);
	QMPset->setValue("MMset/interp", interp);
	QMPset->setValue("MMset/hqmixer", hqmixer);
	QMPset->setValue("MMset/surround", surround);
	QMPset->setValue("MMset/bits16", bits16);
	QMPset->setValue("MMset/stereo", stereo);
	QMPset->setValue("MMset/reverse", reverse);
	QMPset->setValue("MMset/softmusic", softmusic);
	QMPset->setValue("MMset/softsndfx", softsndfx);
	QMPset->setValue("MMset/fadeout", fadeout);
	QMPset->setValue("MMset/loop", loop);
	QMPset->setValue("MMset/pansep", pansep);
	QMPset->setValue("MMset/reverb", reverb);
	QMPset->setValue("MMset/mdvolume", mdvolume);
	QMPset->setValue("MMset/chnMAX", chnMAX);

	QMPset->setValue("MMset/curF", curF);

	QMPset->setValue("MMset/seek", savsek);
	QMPset->setValue("MMset/bpm", savbpm);
	QMPset->setValue("MMset/spd", savspd);
	QMPset->setValue("MMset/timRefValue", timRefValue);

	QMPset->setValue("MMset/formatSupport",formatSupport);
	QMPset->setValue("MMset/Enabled",Enabled);

	QMPset->sync();
	delete QMPset;
}
