void SAVE::odczytajopcje()
{
	bool setsLoaded = false;

	if ( QFile::exists( QMPConf ) )
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("OpenALset/OpenALset").toBool() )
		{
			Enabled = QMPset->value("OpenALset/Enabled").toBool();
			NUM_BUFFERS = QMPset->value("OpenALset/NUM_BUFFERS").toInt();
			onlyMultiChn = QMPset->value("OpenALset/onlyMultiChn").toBool();
			devName = QMPset->value("OpenALset/devName").toString();

			setsLoaded = true;
		}
		delete QMPset;
	}

	if ( !setsLoaded )
	{
		NUM_BUFFERS = 8;
#ifdef Q_WS_WIN32
		Enabled = 1;
		onlyMultiChn = 1;
#else
		Enabled = 0;
		onlyMultiChn = 0;
#endif
	}
}

void SAVE::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("OpenALset/OpenALset",true);

	QMPset->setValue("OpenALset/Enabled",Enabled);
	QMPset->setValue("OpenALset/NUM_BUFFERS",NUM_BUFFERS);
	QMPset->setValue("OpenALset/onlyMultiChn", onlyMultiChn);
	QMPset->setValue("OpenALset/devName", devName);

	QMPset->sync();
	delete QMPset;
}
