void SAVE::odczytajopcje()
{
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("RAWSet/RAWSet").toBool() )
		{
			curF = QMPset->value("RAWSet/curF").toString();

			savsek = QMPset->value("RAWSet/seek").toInt();
			Enabled = QMPset->value("RAWSet/Enabled").toBool();

			srateB = QMPset->value("RAWSet/srateB").toInt();
			chnB = QMPset->value("RAWSet/chnB").toInt();
			u8B = QMPset->value("RAWSet/u8B").toBool();
			BITS = QMPset->value("RAWSet/BITS").toInt();
			be = QMPset->value("RAWSet/be").toBool();

			formatSupport = QMPset->value("RAWSet/formatSupport").toString();

			skipB = QMPset->value( "RAWSet/skipB" ).toInt();

			QMPset->remove( "WAVESet" );

			delete QMPset;

			if ( BITS < 8 || BITS > 33 )
				BITS = 16;

			loaded = true;
		}
	}

	if ( !loaded )
	{
		Enabled = 1;
		formatSupport = "pcm;raw";
		srateB = 44100;
		chnB = 2;
		u8B = 0;
		BITS = 16;
		be = 0;
		skipB = 0;
	}
}

void SAVE::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("RAWSet/RAWSet",true);

	QMPset->setValue("RAWSet/curF", curF );

	QMPset->setValue("RAWSet/seek", savsek);
	QMPset->setValue("RAWSet/Enabled", Enabled);

	QMPset->setValue("RAWSet/srateB", srateB);
	QMPset->setValue("RAWSet/chnB", chnB);
	QMPset->setValue("RAWSet/u8B", u8B);
	QMPset->setValue("RAWSet/BITS", BITS);
	QMPset->setValue("RAWSet/be", be);

	QMPset->setValue("RAWSet/skipB", skipB);

	QMPset->setValue("RAWSet/formatSupport",formatSupport);

	QMPset->sync();
	delete QMPset;
}
