void SAVE::odczytajopcje()
{
	Vis->setMinimumSize(10,10);
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("Vis1/Vis1").toBool() )
		{
			Enabled = QMPset->value("Vis1/Enabled").toBool();
			okno = QMPset->value("Vis1/okno").toBool();
			tims = QMPset->value("Vis1/tims").toInt();
			timRefValue = QMPset->value("Vis1/timRefValue").toInt();

			lpB = QMPset->value("Vis1/lpB").toBool();
			sB = QMPset->value("Vis1/sB").toBool();
			sngTB = QMPset->value("Vis1/sngTB").toBool();

			kreski = QMPset->value("Vis1/kreski").toBool();
			paski = QMPset->value("Vis1/paski").toBool();
			kolor2 = QMPset->value("Vis1/kolor2").toBool();

			VisX = QMPset->value("Vis1/X").toInt();
			VisY = QMPset->value("Vis1/Y").toInt();
			VisW = QMPset->value("Vis1/W").toInt();
			VisH = QMPset->value("Vis1/H").toInt();

			fs.ui.autoFillBackgroundB->setChecked( QMPset->value("Vis1/autoFillBackgroundB").toBool() );

			if ( QMPset->value("Vis1/inDock").toBool() )
				Enabled = false;

			delete QMPset;

			if ( VisW < 1 )
				VisW = 400;
			if ( VisH < 1 )
				VisH = 300;
			if (VisX < 0 )
				VisX = qdw.width()/2 - Vis->width()/2;
			if (VisY < 0 )
				VisY = qdw.height()/2 - Vis->height()/2;

			Vis->setGeometry(VisX,VisY,VisW,VisH);

			loaded = true;
		}
	}

	if ( !loaded )
	{
		lpB = true;
		sB = true;
		sngTB = false;
		Enabled = true;
		okno = true;
		tims = 10;
		VisW = 400;
		VisH = 300;
		VisX = qdw.width()/2 - Vis->width()/2;
		VisY = qdw.height()/2 - Vis->height()/2;
		timRefValue = 25;

		kreski = 1;
		paski = 1;
		kolor2 = 1;

		fs.ui.autoFillBackgroundB->setChecked( true );

		Vis->setGeometry(VisX,VisY,VisW,VisH);
	}
}

void SAVE::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("Vis1/Vis1",true);

	QMPset->setValue("Vis1/Enabled",Enabled);
	QMPset->setValue("Vis1/okno",okno);
	QMPset->setValue("Vis1/tims", tims);
	QMPset->setValue("Vis1/timRefValue", timRefValue);

	QMPset->setValue("Vis1/lpB",lpB);
	QMPset->setValue("Vis1/sB",sB);
	QMPset->setValue("Vis1/sngTB",sngTB);

	QMPset->setValue("Vis1/kreski",kreski);
	QMPset->setValue("Vis1/paski",paski);
	QMPset->setValue("Vis1/kolor2",kolor2);

	QMPset->setValue("Vis1/X",VisX);
	QMPset->setValue("Vis1/Y",VisY);
	QMPset->setValue("Vis1/W",VisW);
	QMPset->setValue("Vis1/H",VisH);

	QMPset->setValue("Vis1/autoFillBackgroundB",fs.ui.autoFillBackgroundB->isChecked());

	QMPset->setValue("Vis1/inDock",inDock);

	QMPset->sync();
	delete QMPset;
}
