void SAVE::odczytajopcje()
{
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("VisXOS/VisXOS").toBool() )
		{
			Enabled = QMPset->value("VisXOS/Enabled").toBool();
			isON = QMPset->value("VisXOS/isON").toBool();
			okno = QMPset->value("VisXOS/okno").toBool();
			timRefValue = QMPset->value("VisXOS/timRefValue").toInt();

			VisX = QMPset->value("VisXOS/X").toInt();
			VisY = QMPset->value("VisXOS/Y").toInt();
			VisW = QMPset->value("VisXOS/W").toInt();
			VisH = QMPset->value("VisXOS/H").toInt();

			if ( QMPset->value("VisXOS/inDock").toBool() )
				Enabled = false;

			delete QMPset;

			loaded = true;
		}
	}

	if ( !loaded )
	{
		isON = false;
		Enabled = false;
		okno = true;
		VisW = 400;
		VisH = 300;
		VisX = -1;
		VisY = -1;
		timRefValue = 15;
	}
}

void SAVE::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("VisXOS/VisXOS",true);

	QMPset->setValue("VisXOS/Enabled",Enabled);
	QMPset->setValue("VisXOS/isON",isON);
	QMPset->setValue("VisXOS/okno",okno);
	QMPset->setValue("VisXOS/timRefValue",timRefValue);

	QMPset->setValue("VisXOS/X",VisX);
	QMPset->setValue("VisXOS/Y",VisY);
	QMPset->setValue("VisXOS/W",VisW);
	QMPset->setValue("VisXOS/H",VisH);

	QMPset->setValue("VisXOS/inDock",inDock);

	QMPset->sync();
	delete QMPset;
}
