void Save::odczytajopcje()
{
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("QEQset/QEQset").toBool() )
		{

			Enabled = QMPset->value("QEQset/Enabled").toBool();
			inSW = QMPset->value("QEQset/inSW").toBool();

			eqgeo = QMPset->value("QEQset/eqgeo").toRect();

			glW = QMPset->value("QEQset/glW").toBool();

			for ( int i = 0 ; i < bands ; i++ )
				valEq[i] = QMPset->value( "QEQset/sl"+QString::number(i) ).toInt();

			delete QMPset;

			if ( eqgeo.y() < 3 )
			{
				eqgeo.setX( qdw.width()/2 - fs.width()/2 );
				eqgeo.setY( qdw.height()/2 - fs.height()/2 );
				eqgeo.setSize( fs.minimumSize() );
				fs.setGeometry(eqgeo);
			}

			loaded = true;
		}
	}

	if ( !loaded )
	{
		Enabled = 0;
		inSW = 1;
		glW = 0;
		eqgeo.setX( qdw.width()/2 - fs.width()/2 );
		eqgeo.setY( qdw.height()/2 - fs.height()/2 );
		eqgeo.setSize( fs.minimumSize() );
		fs.setGeometry(eqgeo);
		fs.clrB();
	}
}

void Save::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("QEQset/QEQset",true);

	QMPset->setValue("QEQset/Enabled",Enabled);
	QMPset->setValue("QEQset/inSW",inSW);

	QMPset->setValue("QEQset/eqgeo",eqgeo);

	QMPset->setValue("QEQset/glW",glW);

	for ( int i = 0 ; i < bands ; i++ )
		QMPset->setValue( "QEQset/sl"+QString::number(i),valEq[i] );

	QMPset->sync();
	delete QMPset;
}
