void FormAbout::cleanB()
{
	FILE *flog = fopen(LogFile.toAscii(),"wb");
	if (flog)
		fclose(flog);
	remove( LogFile.toAscii() );
	ui.logE->clear();
	ref();
}

void FormAbout::Init()
{
	ui.label_ver->setText( QMPVersion );

	fa.setGeometry( faGeo );

	ui.kBB->setValue( kBB );

	ref();

	FILE *f = fopen( "ChangeLog_QMPlay.txt", "rb" );
	if ( f )
	{
		fseek( f, 0, 2 );
		int fsize = ftell(f);
		fseek( f, 0, 0 );
		char *tmp = new char[ fsize ];
		fread( tmp, 1, fsize-1, f );
		fclose( f );
		tmp[ fsize-1 ] = '\0';
		ui.changeLogE->append( QString::fromUtf8( tmp ) );
		delete[] tmp;
		ui.changeLogE->moveCursor( QTextCursor::Start );
	}
}

void FormAbout::add( QString a )
{
	FILE * flog = fopen(LogFile.toAscii(),"ab");

	if ( !flog )
		return;

	a += 13;
	a += 10;

	QString TMP = "["+QDate::currentDate().toString( "dd.MM.yyyy" )+" "+QTime::currentTime().toString( "hh:mm:ss" )+"] "+a;

	fputs( TMP.toUtf8(), flog );

	fclose(flog);
}

void FormAbout::closeEvent(QCloseEvent*)
{
	ui.logE->clear();
	ui.changeLogE->clear();

	faGeo = geometry();

	kBB = ui.kBB->value();
}

void FormAbout::ref()
{
	FILE *flog = fopen(LogFile.toAscii(), "rb");

	if ( !flog )
	{
		ui.kBL->setText( "0kB" );
		return;
	}

	fseek(flog,0,2);
	int size = ftell(flog);
	fseek(flog,0,0);

	char *log = new char[size];
	fread( log, size-1, 1, flog );
	log[size-1] = '\0';
	fclose(flog);

	ui.logE->clear();
	ui.logE->append( QString::fromUtf8( log ) );

	delete[] log;

	ui.kBL->setText( QString::number( size / 1024 ) + "kB" );
}

void FormAbout::clrLog()
{
	FILE * flog = fopen(LogFile.toAscii(),"rb");

	if ( !flog )
		return;

	fseek(flog,0,2);
	int size = ftell(flog);
	fseek(flog,0,0);

	fclose(flog);

	if ( size > kBB*1024 )
	{
		FILE * flog = fopen(LogFile.toAscii(), "wb");

		if ( !flog )
			return;

		fclose(flog);
	}
}
