void Save::resetWindows()
{
	fpGeo.setX( qdw.width()/2 - fp.width()/2 );
	fpGeo.setY( qdw.height()/2 - fp.height()/2 );
	fpGeo.setWidth( f1.width() );
	fpGeo.setHeight( fp.height() );

	f1Geo.setX( qdw.width() / 2  - f1.width() / 2 );
	f1Geo.setY( qdw.height() / 2 - f1h/2 - fp.height()/2 );
	f1Geo.setWidth( f1.width() );
	f1Geo.setHeight( f1.height() );

	fsGeo.setX( qdw.width()/2 - fs.width()/2 );
	fsGeo.setY( qdw.height()/2 - fs.height()/2 );
	fsGeo.setWidth( fs.width() );
	fsGeo.setHeight( fs.height() );

	ffGeo.setX( qdw.width()/2 - ff.width()/2 );
	ffGeo.setY( qdw.height()/2 - ff.height()/2 );
	ffGeo.setWidth( ff.width() );
	ffGeo.setHeight( ff.height() );

	faGeo.setX( qdw.width()/2 - fa.width()/2 );
	faGeo.setY( qdw.height()/2 - fa.height()/2 );
	faGeo.setWidth( fa.width() );
	faGeo.setHeight( fa.height() );

	fprPos.setX( qdw.width()/2 - fpr.width()/2 );
	fprPos.setY( qdw.height()/2 - fpr.height()/2 );
}

void Save::odczytajopcje()
{
	searchAction->setCheckable( true );
	searchAction->setChecked( false );

	bool loaded = false;

	if ( QFile::exists( QMPConf ) )
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
	else
		QMPset = NULL;

	uint oldQMPVer = 0;
	if ( QMPset )
	{
		uint QMPVersionI = 0;
		uchar QMPVer2 = 0;
		QMPVersionI = QMPset->value("QMPset/lastAppVer").toInt();
		QMPVer2 = QMPset->value("QMPset/lastAppVer2").toInt();
		oldQMPVer = QMPVersionI * 10 + QMPVer2;
		if ( oldQMPVer > 0 && oldQMPVer < 1516-1 )
		{
			QMPset->setValue( "QMPset/QMPset", true );
			QMPset->setValue( "WindowGeo/WindowGeo", true );
			QMPset->setValue( "WindowPos/WindowPos", true );
		}
	}

	if
	(
		QMPset                                          &&
		QMPset->value( "WindowGeo/WindowGeo" ).toBool() &&
		QMPset->value( "WindowPos/WindowPos" ).toBool() &&
		QMPset->value( "QMPset/QMPset" ).toBool()
	)
	{
		f1Geo = QMPset->value( "WindowGeo/f1Geo" ).toRect();
		fpGeo = QMPset->value( "WindowGeo/fpGeo" ).toRect();
		fsGeo = QMPset->value( "WindowGeo/fsGeo" ).toRect();
		ffGeo = QMPset->value( "WindowGeo/ffGeo" ).toRect();
		faGeo = QMPset->value( "WindowGeo/faGeo" ).toRect();
		fprPos = QMPset->value( "WindowGeo/fprPos" ).toPoint();

		formInfo.posX = QMPset->value("WindowPos/fIposX").toInt();
		formInfo.posY = QMPset->value("WindowPos/fIposY").toInt();


		styl = QMPset->value("QMPset/styl").toString();
		language = QMPset->value("QMPset/language").toString();

		curP = QMPset->value("QMPset/curP").toString();

		Bpmpp = QMPset->value("QMPset/Bpmpp").toBool();

		fs.ui.savposBox->setChecked( QMPset->value("QMPset/ispl").toBool() );

		if ( fs.ui.savposBox->isChecked() )
			isPlaying = QMPset->value("QMPset/isPlaying").toBool();
		else
			ycPos=true;

		zipl = QMPset->value("QMPset/zipl").toBool();
		zvpl = QMPset->value("QMPset/zvpl").toBool();
		zplV = QMPset->value("QMPset/zplV").toBool();
		zdefB = QMPset->value("QMPset/zdefB").toBool();
		proce = QMPset->value("QMPset/proce").toInt();

		errnxt = QMPset->value("QMPset/errnxt").toBool();
		playnxt = QMPset->value("QMPset/playnxt").toBool();
		listplaylist = QMPset->value("QMPset/listplaylist").toBool();
		fp.listPlaylst();

		savplist = QMPset->value("QMPset/savplist").toBool();
		closeExportOnNxt = QMPset->value("QMPset/closeExportOnNxt").toBool();
		po = QMPset->value("QMPset/po").toInt();

		shwplaylist = QMPset->value("Plist/shwplaylist").toBool();
		fpnf1 = QMPset->value("Plist/fpnf1").toBool();
		fpzf1 = QMPset->value("Plist/fpzf1").toBool();

		fs.ui.pbLBox->setChecked( QMPset->value("QMPset/pbL").toBool() );
		fs.ui.pbRBox->setChecked( QMPset->value("QMPset/pbR").toBool() );

		nextXsV = QMPset->value("QMPset/nextXsV").toInt();
		inTray = QMPset->value("QMPset/inTray").toBool();
		if ( !QSystemTrayIcon::isSystemTrayAvailable() && inTray )
			inTray = false;
		kBB = QMPset->value("QMPset/kBB").toInt();
		bladinfoB = QMPset->value("QMPset/bladinfoB").toBool();
		uPLe = QMPset->value("QMPset/uPLe").toBool();
		uPLeL = QMPset->value("QMPset/uPLeL").toBool();
		mQmpVisible = QMPset->value("QMPset/mQmpVisible").toBool();

		fileStruct = QMPset->value("QMPset/fileStruct").toBool();
		unknownType = QMPset->value("QMPset/unknownType").toBool();
		if ( !QMPset->value("QMPset/scB").toBool() )
		{
			fst.ui.ccB->setChecked(true);
			colorScheme = QMPset->value("QMPset/colorScheme").toString();
			if ( colorScheme.isEmpty() )
				colorScheme = defColorScheme;
		}
		else
			fst.ui.scB->setChecked(true);

		inDockObjName = QMPset->value("QMPset/dock").toString();
		fsMaximized = QMPset->value("QMPset/isMaximized").toBool();
		fileFilter = QMPset->value("QMPset/fileFilter").toBool();
		chImgs = QMPset->value("QMPset/chImgs").toBool();
		searchAction->setChecked( QMPset->value("QMPset/searchInAllLists").toBool() );
		seekTime = QMPset->value("QMPset/seekTime").toBool();
		eoplB = QMPset->value("QMPset/eoplB").toBool();
		autoUpdates = QMPset->value("QMPset/autoUpdates").toBool();
		svrAddress = QMPset->value("QMPset/svrAddress").toString();
		lastVer = QMPset->value("QMPset/lastVer").toUInt();

		//Lista playlist
		listPLst[0].clear();
		listPLst[1].clear();
		listPLst[0] += QMPset->value("ListPlist/fname").toStringList();
		listPLst[1] += QMPset->value("ListPlist/name").toStringList();
		fp.createLPList(); //tworzy listę playlist
		fp.ui.listPlaylst->setCurrentRow( QMPset->value("ListPlist/row").toInt() );

		//Playlista
		if ( savplist )
		{
			playList[0].clear();
			playList[1].clear();
			playList[2].clear();
			playList[3].clear();
			playList[4].clear();

			playList[1] += QMPset->value("Plist/items_type").toStringList();
			playList[3] += QMPset->value("Plist/items_times").toStringList();
			playList[2] += QMPset->value("Plist/items").toStringList();
			playList[0] += QMPset->value("Plist/items_titlelist").toStringList();
			playList[4] += QMPset->value("Plist/selItems").toStringList();
			plistTime = QMPset->value("Plist/items_titlelist_timeI" ).toInt();

			fp.createList();

			int _curplay = QMPset->value("Plist/curplay").toInt();
			if ( _curplay < 0 )
				_curplay = 0;
			if ( _curplay > titlelist->count() - 1 )
				_curplay = 0;
			titlelist->setCurrentRow( _curplay );

			plistthr.plus = QMPset->value("Plist/items_titlelist_+" ).toChar();

			if ( plistthr.plus != '+' )
				plistthr.plus = 32;

			fp.ui.plistTime->setText( Func.timeFormat( plistTime, 0 ) + plistthr.plus );
		}

		QString fname = QMPset->value( "QMPset/updateFName" ).toString();
		if ( !fname.isEmpty() )
		{
			fname = qApp->applicationDirPath() + "/" + fname;
			if ( oldQMPVer < QMPVer && QFile::exists( fname ) )
				QFile::remove( fname );
		}
		QMPset->setValue( "QMPset/updateFName", "" );

		if ( playList[0].size() < 1 )
			isPlaying = false;

		if ( svrAddress.isEmpty() )
			svrAddress = QMPUpdatesAddress;

		if ( language.isEmpty() )
			language = "Polski";

		if ( kBB < 128 || kBB > 1024 )
			kBB = 1024;

		if ( oldQMPVer > 0 )
		{
			if ( oldQMPVer < 1515-1 )
			{
				resetWindows();
				QMPset->remove( "WindowPos" );
#ifndef Q_WS_WIN
				QFile::remove( "plugins/libqmp_plugin_wav" + libExt );
#endif
			}
			if ( oldQMPVer < 1519-1 )
			{
				QMPset->remove( "FuncWrzuta" );
#ifndef Q_WS_WIN
				QFile::remove( "plugins/libqmp_plugin_func_wrzuta" + libExt );
#endif
			}
			if ( oldQMPVer < 1519 ) //1.51.10
			{
				fileStruct = true;
				unknownType = true;
			}
			if ( oldQMPVer < 1524-1 )
			{
				QMPset->remove( "MP3Set" );
#ifndef Q_WS_WIN
				QFile::remove( "plugins/lib/libmpg123" + libExt );
				QFile::remove( "plugins/lib/libresample" + libExt );
#endif
			}
			if ( oldQMPVer < 1529-1 )
			{
				QMPset->remove( "QMPOut/BufQForce" );
				QMPset->setValue( "QMPOut/buffQIfNeaded", false );
				QMPset->setValue( "QMPOut/visEff", true );
				QMPset->setValue( "QMPOut/QBuf", QMPset->value( "QMPOut/QBuf" ) == 8 ? 16 : QMPset->value( "QMPOut/QBuf" ) );
			}
			if ( oldQMPVer < 1532-1 )
			{
				if ( oldQMPUpdatesAddress == svrAddress )
					svrAddress = QMPUpdatesAddress;
			}
		}

		delete QMPset;

		int MinWindowPosX = 0;
		int MinWindowPosY = 0;
#ifdef Q_WS_WIN
		MinWindowPosX = 1;
		MinWindowPosY = 1;
#endif

		if ( f1Geo.x() < MinWindowPosX )
			f1Geo.setX( qdw.width() / 2  - f1.width() / 2 );
		if ( f1Geo.y() < MinWindowPosY )
			f1Geo.setY( qdw.height() / 2 - f1.height() / 2 );
		if ( f1Geo.width() < 1 )
			f1Geo.setWidth( f1.width() );
		if ( f1Geo.height() < 1 )
			f1Geo.setHeight( f1.height() );

		if ( fpGeo.x() < MinWindowPosX )
			fpGeo.setX( qdw.width() / 2  - fp.width() / 2 );
		if ( fpGeo.y() < MinWindowPosY )
			fpGeo.setY( qdw.height()/2 - fp.height() / 2 );
		if ( fpGeo.width() < 1 )
			fpGeo.setWidth( fp.width() );
		if ( fpGeo.height() < 1 )
			fpGeo.setHeight( fp.height() );

		if ( fsGeo.x() < MinWindowPosX )
			fsGeo.setX( qdw.width() / 2  - fs.width() / 2 );
		if ( fsGeo.y() < MinWindowPosY )
			fsGeo.setY( qdw.height()/2 - fs.height() / 2 );
		if ( fsGeo.width() < 1 )
			fsGeo.setWidth( fs.width() );
		if ( fsGeo.height() < 1 )
			fsGeo.setHeight( fs.height() );

		if ( ffGeo.x() < MinWindowPosX )
			ffGeo.setX( qdw.width() / 2  - ff.width() / 2 );
		if ( ffGeo.y() < MinWindowPosY )
			ffGeo.setY( qdw.height()/2 - ff.height() / 2 );
		if ( ffGeo.width() < 1 )
			ffGeo.setWidth( ff.width() );
		if ( ffGeo.height() < 1 )
			ffGeo.setHeight( ff.height() );

		if ( faGeo.x() < MinWindowPosX )
			faGeo.setX( qdw.width() / 2  - fa.width() / 2 );
		if ( faGeo.y() < MinWindowPosY )
			faGeo.setY( qdw.height()/2 - fa.height() / 2 );
		if ( faGeo.width() < 1 )
			faGeo.setWidth( fa.width() );
		if ( faGeo.height() < 1 )
			faGeo.setHeight( fa.height() );

		if ( fprPos.x() < MinWindowPosX )
			fprPos.setX( qdw.width()/2 - fpr.width()/2 );
		if ( fprPos.y() < MinWindowPosY )
			fprPos.setY( qdw.height()/2 - fpr.height()/2 );

		if ( formInfo.posX < MinWindowPosX )
			formInfo.posX = qdw.width()/2 - formInfo.width()/2;
		if ( formInfo.posY < MinWindowPosY )
			formInfo.posY = qdw.height()/2 - formInfo.height()/2;

		loaded = true;
	}

	if ( !loaded )
	{
		resetWindows();

		formInfo.posX = qdw.width() /2 - formInfo.width()/2;
		formInfo.posY = qdw.height()/2 - formInfo.height()/2;


		language = "Polski";

		isPlaying = false;
		curP = QDir::homePath();
		shwplaylist = true;

		proce = 10;

		fpnf1=true;
		fpzf1=false;

		zplV=true;
		zipl=false;
		zvpl = false;
		zdefB = true;

		playnxt = true;
		savplist = true;
		fp.listPlaylst();
		plistthr.plus = 32;
		po = 0;

		uPLe = true;
		uPLeL = true;
		fileStruct = true;
		unknownType = true;
		kBB = 512;
		nextXsV = 10;
		selMus = false;

		styl = Default_QMP_style;

		bladinfoB = false;

		fst.ui.ccB->setChecked(true);
		colorScheme = defColorScheme;

		fileFilter = true;
		listplaylist = true;
		fp.listPlaylst();
		chImgs = true;

		seekTime = false;
		eoplB = true;

		if ( QFile::exists( "noautoupdates" ) )
			autoUpdates = false;
		else
			autoUpdates = true;

		svrAddress = QMPUpdatesAddress;

		FirstTime = true; //dołącza pierwszą wizualizację do "okienka"
	}
}

void Save::zapiszopcje()
{
	if ( usunSets )
		return;

	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue( "QMPset/QMPset", true );
	QMPset->setValue( "WindowGeo/WindowGeo", true );
	QMPset->setValue( "WindowPos/WindowPos", true );

	QMPset->setValue("QMPset/lastAppPath", qApp->applicationDirPath());
	QMPset->setValue("QMPset/lastQMPExec", Func.plikbezsciezki(qApp->applicationFilePath()));
	QMPset->setValue("QMPset/lastAppVer" , QMPVersionI);
	QMPset->setValue("QMPset/lastAppVer2" , QMPVer2);

	if ( !isPlaying )
		nrplay = titlelist->currentRow();

	if ( !f1.isMaximized() )
		QMPset->setValue( "WindowGeo/f1Geo", f1Geo );
	QMPset->setValue( "WindowGeo/fpGeo", fpGeo );
	QMPset->setValue( "WindowGeo/fsGeo", fsGeo );
	QMPset->setValue( "WindowGeo/ffGeo", ffGeo );
	QMPset->setValue( "WindowGeo/faGeo", faGeo );
	QMPset->setValue( "WindowGeo/fprPos", fprPos );

	QMPset->setValue("WindowPos/fIposX",formInfo.posX);
	QMPset->setValue("WindowPos/fIposY",formInfo.posY);


	QMPset->setValue("QMPset/styl",styl);
	QMPset->setValue("QMPset/language",language);

	QMPset->setValue("QMPset/Bpmpp", Bpmpp);

	if ( fs.ui.savposBox->isChecked() )
	{
		QMPset->setValue("QMPset/ispl",true);
		QMPset->setValue("QMPset/isPlaying", isPlaying);
	}
	else
	{
		QMPset->setValue("QMPset/ispl",false);
		QMPset->setValue("QMPset/isPlaying", false);
	}

	QMPset->setValue("QMPset/zipl", zipl);
	QMPset->setValue("QMPset/zvpl", zvpl);
	QMPset->setValue("QMPset/zplV", zplV);
	QMPset->setValue("QMPset/zdefB", zdefB);
	QMPset->setValue("QMPset/proce",proce);

	QMPset->setValue("QMPset/errnxt", errnxt);
	QMPset->setValue("QMPset/playnxt", playnxt);
	QMPset->setValue("QMPset/listplaylist", listplaylist);
	QMPset->setValue("QMPset/savplist", savplist);
	QMPset->setValue("QMPset/closeExportOnNxt", closeExportOnNxt);
	QMPset->setValue("QMPset/po", po);

	if ( !bezzapisulisty && !plistthr.isRunning() )
		QMPset->remove("Plist");

	QMPset->setValue("Plist/shwplaylist", shwplaylist);
	QMPset->setValue("Plist/fpnf1", fpnf1);
	QMPset->setValue("Plist/fpzf1", fpzf1);

	if ( fs.ui.pbLBox->isChecked() )
		QMPset->setValue("QMPset/pbL",true);
	else
		QMPset->setValue("QMPset/pbL",false);
	if ( fs.ui.pbRBox->isChecked() )
		QMPset->setValue("QMPset/pbR",true);
	else
		QMPset->setValue("QMPset/pbR",false);

	QMPset->setValue("QMPset/nextXsV",nextXsV);
	QMPset->setValue("QMPset/inTray",inTray);
	QMPset->setValue("QMPset/kBB",kBB);;
	QMPset->setValue("QMPset/bladinfoB",bladinfoB);
	QMPset->setValue("QMPset/uPLe",uPLe); //odświeża wpis w playliście po rozpoczęciu odtwarzania
	QMPset->setValue("QMPset/uPLeL",uPLeL); //odczytuje z playlist m3u i pls tytuly i czas (szybkie ładowanie)
	QMPset->setValue("QMPset/fileStruct",fileStruct);
	QMPset->setValue("QMPset/unknownType",unknownType);
	QMPset->setValue("QMPset/scB",fst.ui.scB->isChecked());
	QMPset->setValue("QMPset/colorScheme",colorScheme);

	QMPset->setValue("QMPset/dock",inDockObjName);
	QMPset->setValue("QMPset/isMaximized",f1.isMaximized());
	QMPset->setValue("QMPset/fileFilter",fileFilter);
	QMPset->setValue("QMPset/chImgs",chImgs);
	QMPset->setValue("QMPset/searchInAllLists",searchAction->isChecked());
	QMPset->setValue("QMPset/mQmpVisible",mQmpVisible);
	QMPset->setValue("QMPset/seekTime",seekTime);
	QMPset->setValue("QMPset/eoplB",eoplB);
	QMPset->setValue("QMPset/autoUpdates",autoUpdates);
	QMPset->setValue("QMPset/svrAddress",svrAddress);
	QMPset->setValue("QMPset/lastVer",lastVer);

	if ( !bezzapisulisty )
	{
		//Lista playlist
		QMPset->setValue("ListPlist/fname",listPLst[0]);
		QMPset->setValue("ListPlist/name",listPLst[1]);
		QMPset->setValue("ListPlist/row",fp.ui.listPlaylst->currentRow());

		//Playlista
		if ( plistthr.isRunning() )
			plistthr.doExit();
		else if ( savplist )
		{
			QMPset->setValue("QMPset/curP", curP);

			QStringList plQSL;
			for ( int i = 0 ; i<playList[2].size() ; i++)
				plQSL += playList[2][i];
			QMPset->setValue("Plist/items", plQSL );
			QMPset->setValue("Plist/items_titlelist", playList[0] );
			QMPset->setValue("Plist/items_times", playList[3] );
			QMPset->setValue("Plist/items_type", playList[1] );
			QMPset->setValue("Plist/items_titlelist_timeI" , plistTime );

			QMPset->setValue("Plist/curplay", nrplay );

			QMPset->setValue("Plist/items_titlelist_+", plistthr.plus );

			QMPset->setValue("Plist/selItems", playList[4] );
		}
	}
	bezzapisulisty = 0;

	QMPset->setValue("QMPset/updateFName",fd.fname);

	QMPset->sync();
	delete QMPset;
}
