#ifndef VideoData_H
#define VideoData_H

#include <QQueue>

struct VideoData
{
	VideoData()
	{
		clearBuff = false;
		visplugin_idx = -1;
		aspect_ratio = delay = W = H = 0;
		menu = NULL;
	}
	~VideoData()
	{
		clrQ( true );
	}
	void clrQ( bool clrAll )
	{
		while ( vidQ.size() - !clrAll > 0 )
			delete vidQ.dequeue();
	}
	struct frame
	{
		frame( uchar *_data, int _numBytes )
		{
			numBytes = _numBytes;
			data = new uchar[ numBytes ];
			memcpy( data, _data, numBytes );
		};
		~frame()
		{
			delete[] data;
		}
		uchar *data;
		int numBytes;
	};
	QQueue < frame * > vidQ;
	float delay, aspect_ratio;
	bool clearBuff;
	int W, H, visplugin_idx;
	struct QMenu *menu;
};

#endif
