#!/bin/sh

mkdir qmplay_binary
mkdir qmplay_binary/styles
mkdir qmplay_binary/lang
mkdir qmplay_binary/colors
mkdir qmplay_binary/plugins
mkdir qmplay_binary/lib

cp COPYING qmplay_binary

cd qmp
make && cp qmplay ../qmplay_binary

cd ../qmp_curl
make && cp *.so ../qmplay_binary/lib
cd ../qmp_export
make && cp *.so ../qmplay_binary/lib
cd ../qmp_out
make && cp *.so ../qmplay_binary/lib
cd ../qmp_lib
make && cp *.so ../qmplay_binary/lib
cd ../qmp_equalizer
make && cp *.so ../qmplay_binary/lib
cd ../plugins/playlists
make && cp *.so ../../qmplay_binary/plugins
cd ../openal
make && cp *.so ../../qmplay_binary/plugins
cd ../cdda
make && cp *.so ../../qmplay_binary/plugins
cd ../portaudio
make && cp *.so ../../qmplay_binary/plugins
cd ../effect_tst
make && cp *.so ../../qmplay_binary/plugins
cd ../effect_resample
make && cp *.so ../../qmplay_binary/plugins
cd ../func_rec
make && cp *.so ../../qmplay_binary/plugins
cd ../func_tag_editor
make && cp *.so ../../qmplay_binary/plugins
cd ../func_music_browser
make && cp *.so ../../qmplay_binary/plugins
cd ../mikmod
make && cp *.so ../../qmplay_binary/plugins
cd ../modplug
make && cp *.so ../../qmplay_binary/plugins
cd ../ogg
make && cp *.so ../../qmplay_binary/plugins
cd ../aac
make && cp *.so ../../qmplay_binary/plugins
cd ../mp3
make && cp *.so ../../qmplay_binary/plugins
cd ../vis_tst
make && cp *.so ../../qmplay_binary/plugins
cd ../vis_fft
make && cp *.so ../../qmplay_binary/plugins
cd ../vis_xmms_opengl_spectrum
make && cp *.so ../../qmplay_binary/plugins
cd ../raw
make && cp *.so ../../qmplay_binary/plugins
cd ../sndfile
make && cp *.so ../../qmplay_binary/plugins
cd ../snd_generator
make && cp *.so ../../qmplay_binary/plugins
cd ../../

cd other/QtCurve/style
make && cp *.so ../../../qmplay_binary/styles/qtcurve.so && rm -f *.so*
cd ../../../

cp qmp/colors/*.qmpcolor qmplay_binary/colors
cp qmp/lang/*.qmplang qmplay_binary/lang
cp qmp/ChangeLog_QMPlay.txt qmplay_binary
