void SAVE::odczytajopcje()
{
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("AOset/AOset").toBool() )
		{
			Enabled = QMPset->value("AOset/Enabled").toBool();
			drvid = QMPset->value("AOset/drvid").toInt();

			delete QMPset;

			loaded = true;
		}
	}

	if ( !loaded )
	{
		ao_initialize();
		drvid = ao_default_driver_id();
#ifndef Q_OS_FREEBSD
		Enabled = 0;
#else
		Enabled= 1;
#endif
	}
}

void SAVE::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("AOset/AOset",true);

	QMPset->setValue("AOset/Enabled",Enabled);
	QMPset->setValue("AOset/drvid",drvid);

	QMPset->sync();
	delete QMPset;
}
