bool getServer( QString p, QString &name, unsigned short &port )
{
	if ( p.length() < 3 )
		return false;
	QStringList pL = p.split(":", QString::SkipEmptyParts);
	if ( pL.count() != 2 )
		return false;
	name = pL[0];
	port = pL[1].toInt();
	return true;
}

void SAVE::odczytajopcje()
{
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("QMPInternet/QMPInternet").toBool() )
		{
			useProxy = QMPset->value("QMPInternet/useProxy").toBool();
			if (useProxy)
				useProxy = getServer( QMPset->value("QMPInternet/proxy").toString(), proxyAddr, proxyPort );
		}
		if ( QMPset->value("CDAudio/CDAudio").toBool() )
		{
			fisW = QMPset->value("CDAudio/fisW").toInt();
			fisH = QMPset->value("CDAudio/fisH").toInt();

			fs.ui.canCloseTB->setChecked( QMPset->value("CDAudio/canCloseTB").toBool() );

			curF = QMPset->value("CDAudio/curF").toString();

			savsek = QMPset->value("CDAudio/seek").toInt();
			Enabled = QMPset->value("CDAudio/Enabled").toBool();
			speed = QMPset->value("CDAudio/speed").toInt();
			clrB = QMPset->value("CDAudio/clrB").toBool();

			currCD = QMPset->value("CDAudio/currCD").toString();
			if ( currCD.isEmpty() )
				loadFirst = true;

			useDefaultCacheDir = QMPset->value("CDAudio/useDefaultCacheDir").toBool();
			useCDDB = QMPset->value("CDAudio/useCDDB").toBool();

			useUserDatabase = QMPset->value("CDAudio/useUserDatabase").toBool();
			useFDB = QMPset->value("CDAudio/useFDB").toBool();
			useFDB2 = QMPset->value("CDAudio/useFDB2").toBool();
			useCddbp = QMPset->value("CDAudio/useCddbp").toBool();
			userDatabaseServer = QMPset->value("CDAudio/userDatabaseServer").toString();

			readCDTXT = QMPset->value("CDAudio/readCDTXT").toBool();

			if ( !useUserDatabase && !useFDB && !useFDB2 )
				useFDB2 = true;

			delete QMPset;

			loaded = true;
		}
	}

	if ( !loaded )
	{
		loadFirst = true;
#ifndef WIN32
		fs.ui.canCloseTB->setChecked( true );
#endif
		Enabled = true;
		speed = 1;
		clrB = true;
		useDefaultCacheDir = true;
		useCDDB = true;
		useUserDatabase = false;
		useFDB = false;
		useFDB2 = true;
		useCddbp = false;
		readCDTXT = true;
	}
}

void SAVE::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("CDAudio/CDAudio",true);

	QMPset->setValue("CDAudio/fisW",fisW);
	QMPset->setValue("CDAudio/fisH",fisH);

	QMPset->setValue("CDAudio/canCloseTB", fs.ui.canCloseTB->isChecked() );

	QMPset->setValue("CDAudio/curF", curF );

	QMPset->setValue("CDAudio/seek", savsek);
	QMPset->setValue("CDAudio/Enabled", Enabled);
	QMPset->setValue("CDAudio/speed", speed);
	QMPset->setValue("CDAudio/clrB", clrB);

	QMPset->setValue("CDAudio/currCD", currCD);

	QMPset->setValue("CDAudio/useDefaultCacheDir",useDefaultCacheDir);
	QMPset->setValue("CDAudio/useCDDB",useCDDB);

	QMPset->setValue("CDAudio/useUserDatabase",useUserDatabase);
	QMPset->setValue("CDAudio/useFDB",useFDB);
	QMPset->setValue("CDAudio/useFDB2",useFDB2);
	QMPset->setValue("CDAudio/useCddbp",useCddbp);
	QMPset->setValue("CDAudio/userDatabaseServer",userDatabaseServer);

	QMPset->setValue("CDAudio/readCDTXT",readCDTXT);

	delete QMPset;
}
