void SAVE::odczytajopcje()
{
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("QEffResample/QEffResample").toBool() )
		{
			Enabled = QMPset->value("QEffResample/Enabled").toBool();
			autoFactor = QMPset->value("QEffResample/autoFactor").toBool();
			factor = QMPset->value("QEffResample/factor").toDouble();

			delete QMPset;

			loaded = true;
		}
	}

	if ( !loaded )
	{
		Enabled = true;
		autoFactor = true;
		factor = 1.0;
	}
}

void SAVE::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("QEffResample/QEffResample",true);

	QMPset->setValue("QEffResample/Enabled",Enabled);
	QMPset->setValue("QEffResample/autoFactor",autoFactor);
	QMPset->setValue("QEffResample/factor",factor);

	QMPset->sync();
	delete QMPset;
}
