void SAVE::odczytajopcje()
{
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("QEff1/QEff1").toBool() )
		{
			Enabled = QMPset->value("QEff1/Enabled").toBool();
			effEcho = QMPset->value("QEff1/effEcho").toBool();
			effVoice = QMPset->value("QEff1/effVoice").toBool();
			effSkip = QMPset->value("QEff1/effSkip").toBool();
			effSzybko = QMPset->value("QEff1/effSzybko").toBool();
			effWolno = QMPset->value("QEff1/effWolno").toBool();

			voice = QMPset->value("QEff1/voice").toBool();
			echoSurround = QMPset->value("QEff1/echoSurround").toBool();

			p1s = QMPset->value("QEff1/p1s").toInt();
			p2s = QMPset->value("QEff1/p2s").toInt();

			echo_delay = QMPset->value("QEff1/echo_delay").toInt();
			echo_feedback = QMPset->value("QEff1/echo_feedback").toInt();
			echo_volume = QMPset->value("QEff1/echo_volume").toInt();

			effInvert = QMPset->value("QEff1/effInvert").toInt();

			delete QMPset;

			loaded = true;
		}
	}

	if ( !loaded )
	{
		Enabled = false;

		effEcho = false;
		effVoice = false;
		effSkip = false;
		effWolno = false;
		effSzybko = false;

		echoSurround = false;
		voice = true;

		echo_delay = 500;
		echo_feedback = 50;
		echo_volume = 50;

		p1s = 28;
		p2s = 25;
	}
}

void SAVE::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("QEff1/QEff1",true);

	QMPset->setValue("QEff1/Enabled",Enabled);
	QMPset->setValue("QEff1/effEcho",effEcho);
	QMPset->setValue("QEff1/effVoice",effVoice);
	QMPset->setValue("QEff1/effSkip",effSkip);
	QMPset->setValue("QEff1/effSzybko",effSzybko);
	QMPset->setValue("QEff1/effWolno",effWolno);

	QMPset->setValue("QEff1/voice",voice);
	QMPset->setValue("QEff1/echoSurround",echoSurround);

	QMPset->setValue("QEff1/p1s",p1s);
	QMPset->setValue("QEff1/p2s",p2s);

	QMPset->setValue("QEff1/echo_delay",echo_delay);
	QMPset->setValue("QEff1/echo_feedback",echo_feedback);
	QMPset->setValue("QEff1/echo_volume",echo_volume);

	QMPset->setValue("QEff1/effInvert",effInvert);

	QMPset->sync();
	delete QMPset;
}
