void opcje(QWidget*)
{
}

void setSize( QSize s )
{
	QRect g;
	g.setX(0);
	g.setY(0);
	g.setHeight(s.height());
	g.setWidth(s.width());
	f1.setGeometry(g);
}

void Show(QWidget *w)
{
	if(w)
	{
		w->setMinimumSize( f1.minimumSize() );
		w->setMaximumSize( f1.maximumSize() );
		tmpWidget = w;
	}
	f1.setParent(tmpWidget);
	f1.move(0,0);
	f1.show();
}

void getOutLib(Qmp *_QLib)
{
	QLib = _QLib;
}

void Init()
{
	QMPConf = QLib->getFileName( QMP_CONF );
	libExt = QLib->getFileName( OS_LIBEXT );
	f1.Init();
}

void closePlug()
{
	f1.setParent(NULL);
	f1.close();
}

void about(QWidget *w)
{
	QMessageBox::information(w,"QMPlay","Associate with QMP!");
}

void setLang( QString langfile )
{
	Texts.clear();

	QMPset = new QSettings( langfile , QSettings::IniFormat );

	for ( int i = 0 ; i < langCount ; i++ )
		Texts += QString::fromUtf8( QMPset->value( "QAssociate/" + QString::number(i) ).toString().toAscii() );

	f1.ui.onRunB->setText( QString::fromUtf8( QMPset->value( "QAssociateWindow/0" ).toString().toAscii() ) );
	f1.ui.selAllB->setText( QString::fromUtf8( QMPset->value( "QAssociateWindow/1" ).toString().toAscii() ) );
	f1.ui.revSelB->setText( QString::fromUtf8( QMPset->value( "QAssociateWindow/2" ).toString().toAscii() ) );
	f1.ui.addB->setText( QString::fromUtf8( QMPset->value( "QAssociateWindow/3" ).toString().toAscii() ) );
	f1.ui.delB->setText( QString::fromUtf8( QMPset->value( "QAssociateWindow/4" ).toString().toAscii() ) );
	f1.ui.getExtsB->setText( QString::fromUtf8( QMPset->value( "QAssociateWindow/5" ).toString().toAscii() ) );
	f1.ui.clrB->setText( QString::fromUtf8( QMPset->value( "QAssociateWindow/6" ).toString().toAscii() ) );
	f1.ui.applyB->setText( QString::fromUtf8( QMPset->value( "QAssociateWindow/7" ).toString().toAscii() ) );
	f1.ui.extsList->setWhatsThis( QString::fromUtf8( QMPset->value( "QAssociateWindow/8" ).toString().toAscii() ) );
	f1.ui.extsE->setToolTip( QString::fromUtf8( QMPset->value( "QAssociateWindow/9" ).toString().toAscii() ) );

	delete QMPset;
}
