QString chkFName( QString fname )
{
	fname.truncate(200);

	fname.replace("/","_");
#ifdef Q_WS_WIN
	fname.replace("\\","_");
	fname.replace(":","_");
	fname.replace("*","_");
	fname.replace("?","_");
	fname.replace("\"","_");
	fname.replace("<","_");
	fname.replace(">","_");
	fname.replace("|","_");
#endif
	return fname;
}

void dwnThr::blad( QString addr )
{
	QLib->showMessage("QMPlay",Texts[13] + addr,1,0,false);
	QLib->addToLog( Texts[13] + addr );
}

void dwnThr::run()
{
	loadCURL();
	if ( !CURLloaded )
		return;

	data = new char[4096];

	bool err = false;
	abortAll = false;

	while ( f1.ui.queueW->count() )
	{
		err = false;
		QStringList addrLst = f1.ui.queueW->item(0)->text().split( " -> " );
		QString addr = addrLst[1];
		if ( !addr.isEmpty() && addr != "-" )
		{
			bolBr = false;

			QFile f( pth + "/" + chkFName( addrLst[0] ) );
			if ( !f.open( QIODevice::WriteOnly ) )
			{
				f1.ui.queueW->removeItemWidget( f1.ui.queueW->takeItem( 0 ) );
				blad( addr );
				err = true;
				continue;
			}

			uF = url_fopen( addr.toAscii(), 0, 1 );
			if ( !uF )
			{
				f.close();
				f1.ui.queueW->removeItemWidget( f1.ui.queueW->takeItem( 0 ) );
				blad( addr );
				err = true;
				continue;
			}
			QLib->addToLog( Texts[8] + addr );
			int ile = MAX_ILE*2;
			while( !url_feof( uF ) )
			{
				bread = url_fread( data, 1, 4096, uF );

				if ( !bread && !url_feof( uF ) && !--ile )
				{
					blad( addr );
					err = true;
					break;
				}
				if ( bread )
					ile = MAX_ILE;

				f.write( data, bread );
				spd = getNetInfo(uF,DOWNLOAD_SPEED);
				rem = getNetInfo(uF,FILE_SIZE) - getNetInfo(uF,BYTES_DOWNLOADED);
				siz = getNetInfo(uF,FILE_SIZE);
				dwn = getNetInfo(uF,BYTES_DOWNLOADED);
				pC  = ( (double)dwn / (double)siz ) * 100.;
				if ( bolBr )
					break;
			}
			f.close();
			url_fclose( uF );
		}

		if ( abortAll )
			f1.ui.queueW->clear();
		else
			f1.ui.queueW->removeItemWidget( f1.ui.queueW->takeItem( 0 ) );
	}

	unloadCURL();

	delete[] data;

	if ( !err && !bolBr )
		QLib->showMessage("QMPlay",Texts[15] /* Pobieranie zakonczone */,1,0,false);
}
