#include <tag.h>
#include <fileref.h>

#include <id3v2tag.h>
#include <mpegfile.h>
#include <attachedpictureframe.h>

struct QMPlay_Tag
{
	QMPlay_Tag( const char * );
	~QMPlay_Tag();

	void clear();
	void save();

	bool isNull;
	char *fileName;

	TagLib::String title, artist, album, comment, genre;
	uint year, track;
	TagLib::ByteVector picture; //only ID3V2
};

#include <struct.cpp>
