void SAVE::odczytajopcje()
{
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("MPset/MPset").toBool() )
		{
			curF = QMPset->value("MPSet/curF").toString();

			savsek = QMPset->value("MPset/seek").toInt();

			Enabled = QMPset->value("MPset/Enabled").toBool();

			formatSupport = QMPset->value("MPset/formatSupport").toString();

			vol = QMPset->value("MPset/vol").toInt();
			chn = QMPset->value("MPset/chn").toInt();
			rate = QMPset->value("MPset/rate").toInt();
			bits = QMPset->value("MPset/bits").toInt();
			loop = QMPset->value("MPset/loop").toBool();
			Oversampling = QMPset->value("MPset/Oversampling").toBool();
			NoiseR = QMPset->value("MPset/NoiseR").toBool();
			Resampling = QMPset->value("MPset/Resampling").toInt();

			showTime = QMPset->value("MPset/showTime").toBool();
			bass = QMPset->value("MPset/bass").toBool();
			reverb = QMPset->value("MPset/reverb").toBool();
			surround = QMPset->value("MPset/surround").toBool();

			bass1 = QMPset->value("MPset/bass1").toInt();
			bass2 = QMPset->value("MPset/bass2").toInt();
			reverb1 = QMPset->value("MPset/reverb1").toInt();
			reverb2 = QMPset->value("MPset/reverb2").toInt();
			surround1 = QMPset->value("MPset/surround1").toInt();
			surround2 = QMPset->value("MPset/surround2").toInt();

			fmsW = QMPset->value("MPset/fmsW").toInt();
			fmsH = QMPset->value("MPset/fmsH").toInt();

			delete QMPset;

			loaded = true;
		}
	}

	if ( !loaded )
	{
		fmsW=fm->width();
		fmsH=fm->height();

		bass1 = 50;
		bass2 = 50;

		reverb1 = 50;
		reverb2 = 100;

		surround1 = 50;
		surround2 = 30;

		vol = 255;
		chn = 2;
		rate = 44100;
		bits = 16;
		loop = 0;
		Oversampling = 1;
		NoiseR = 0;
		Resampling = 1;
		Enabled = 1;
		formatSupport = "it;xm;s3m;mod";
	}
}

void SAVE::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("MPset/MPset",true);

	QMPset->setValue("MPset/curF", curF);

	QMPset->setValue("MPset/seek", savsek);

	QMPset->setValue("MPset/Enabled", Enabled);

	QMPset->setValue("MPset/formatSupport",formatSupport);

	QMPset->setValue("MPset/vol",vol);
	QMPset->setValue("MPset/chn",chn);
	QMPset->setValue("MPset/rate",rate);
	QMPset->setValue("MPset/bits",bits);
	QMPset->setValue("MPset/loop",loop);
	QMPset->setValue("MPset/Oversampling",Oversampling);
	QMPset->setValue("MPset/NoiseR",NoiseR);
	QMPset->setValue("MPset/Resampling",Resampling);

	QMPset->setValue("MPset/showTime",showTime);
	QMPset->setValue("MPset/bass",bass);
	QMPset->setValue("MPset/reverb",reverb);
	QMPset->setValue("MPset/surround",surround);

	QMPset->setValue("MPset/bass1",bass1);
	QMPset->setValue("MPset/bass2",bass2);
	QMPset->setValue("MPset/reverb1",reverb1);
	QMPset->setValue("MPset/reverb2",reverb2);
	QMPset->setValue("MPset/surround1",surround1);
	QMPset->setValue("MPset/surround2",surround2);

	QMPset->setValue("MPset/fmsW",fmsW);
	QMPset->setValue("MPset/fmsH",fmsH);

	QMPset->sync();
	delete QMPset;
}
