void Save::odczytajopcje()
{
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("MP3Set/MP3Set").toBool() )
		{
			fosW = QMPset->value("MP3Set/fosW").toInt();
			fosH = QMPset->value("MP3Set/fosH").toInt();

			curF = QMPset->value("MP3Set/curF").toString();

			savsek = QMPset->value("MP3Set/seek").toInt();

			Enabled = QMPset->value("MP3Set/Enabled").toBool();

			notReadID3 = QMPset->value("MP3Set/notReadID3").toBool();

			formatSupport = QMPset->value("MP3Set/formatSupport").toString();

			searchParts = QMPset->value("MP3Set/searchParts").toBool();
			wait4Data = QMPset->value("MP3Set/wait4Data").toBool();

			delete QMPset;

			loaded = true;
		}
	}

	if ( !loaded )
	{
		delete QMPset;
		Enabled = 1;
		notReadID3 = false;
		formatSupport = "mp3";
		searchParts = true;
		wait4Data = true;
	}
}

void Save::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("MP3Set/MP3Set",true);

	QMPset->setValue("MP3Set/fosW",fosW);
	QMPset->setValue("MP3Set/fosH",fosH);

	QMPset->setValue("MP3Set/curF", curF);

	QMPset->setValue("MP3Set/Enabled", Enabled);

	QMPset->setValue("MP3Set/notReadID3",notReadID3);

	QMPset->setValue("MP3Set/seek", savsek);

	QMPset->setValue("MP3Set/formatSupport",formatSupport);

	QMPset->setValue("MP3Set/searchParts",searchParts);
	QMPset->setValue("MP3Set/wait4Data",wait4Data);

	QMPset->sync();
	delete QMPset;
}
