void SAVE::odczytajopcje()
{
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("VorbisSet/VorbisSet").toBool() )
		{
			fosW = QMPset->value("VorbisSet/fosW").toInt();
			fosH = QMPset->value("VorbisSet/fosH").toInt();

			curF = QMPset->value("VorbisSet/curF").toString();

			savsek = QMPset->value("VorbisSet/seek").toInt();
			Enabled = QMPset->value("VorbisSet/Enabled").toBool();

			formatSupport = QMPset->value("VorbisSet/formatSupport").toString();

			delete QMPset;

			loaded = true;
		}
	}

	if ( !loaded )
	{
		fosW = fo->width();
		fosH = fo->height();
		Enabled = 1;
		formatSupport = "ogg";
	}
}

void SAVE::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("VorbisSet/VorbisSet",true);

	QMPset->setValue("VorbisSet/fosW",fosW);
	QMPset->setValue("VorbisSet/fosH",fosH);

	QMPset->setValue("VorbisSet/curF",curF);

	QMPset->setValue("VorbisSet/seek", savsek);

	QMPset->setValue("VorbisSet/Enabled", Enabled);

	QMPset->setValue("VorbisSet/formatSupport",formatSupport);

	QMPset->sync();
	delete QMPset;
}
