void Save::odczytajopcje()
{
#ifndef Q_OS_LINUX
	fs.ui.autoSurroundB->close();
#endif
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("PAset/PAset").toBool() )
		{
			Enabled = QMPset->value("PAset/Enabled").toBool();
			devIndexPA = QMPset->value("PAset/devIndexPA").toInt();
			lB = QMPset->value("PAset/latency").toDouble();
			devIndexNPA = QMPset->value("PAset/devIndexNPA").toInt();
			lNB = QMPset->value("PAset/latencyN").toDouble();
			devIndex = QMPset->value("PAset/devIndex").toInt();
			devIndexN = QMPset->value("PAset/devIndexN").toInt();
			dN  = QMPset->value("PAset/dN").toString();
			dNN = QMPset->value("PAset/dNN").toString();
			zB = QMPset->value("PAset/zB").toBool();
#ifdef Q_OS_LINUX
			autoSurround = QMPset->value("PAset/autoSurround").toBool();
#endif

			delete QMPset;

			if ( devIndexPA < 0 && devIndexNPA < 0 && Enabled )
				fs.defDev();

			loaded = true;
		}
	}

	if ( !loaded )
	{
		Enabled = 1;
		zB = true;
#ifdef Q_OS_MAC
		lB  = 0.05;
		lNB = 0.05;
#else
		lB  = 0.15;
		lNB = 0.15;
#endif
		fs.defDev();
		mustReset = false;
#ifdef Q_OS_LINUX
		autoSurround = true;
#endif
	}
}

void Save::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("PAset/PAset",true);

	QMPset->setValue("PAset/Enabled",Enabled);
	QMPset->setValue("PAset/devIndexPA",devIndexPA);
	QMPset->setValue("PAset/latency",lB);
	QMPset->setValue("PAset/devIndexNPA",devIndexNPA);
	QMPset->setValue("PAset/latencyN",lNB);
	QMPset->setValue("PAset/devIndex",devIndex);
	QMPset->setValue("PAset/devIndexN",devIndexN);
	QMPset->setValue("PAset/dN",dN);
	QMPset->setValue("PAset/dNN",dNN);
	QMPset->setValue("PAset/zB",zB);
#ifdef Q_OS_LINUX
	QMPset->setValue("PAset/autoSurround",autoSurround);
#endif

	QMPset->sync();
	delete QMPset;
}
