int IsPowerOfTwo ( unsigned x )
{
	if ( x < 2 )
		return FALSE;

	if ( x & (x-1) )        // Thanks to 'byang' for this cute trick!
		return FALSE;

	return TRUE;
}

void SAVE::odczytajopcje()
{
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("VisFFT1/VisFFT1").toBool() )
		{
			isON = QMPset->value("VisFFT1/isON").toBool();
			Enabled = QMPset->value("VisFFT1/Enabled").toBool();
			okno = QMPset->value("VisFFT1/okno").toBool();
			fftP = QMPset->value("VisFFT1/fftP").toBool();
			fftL = QMPset->value("VisFFT1/fftL").toBool();
			fftsize = QMPset->value("VisFFT1/fftsize").toInt();
			scale = QMPset->value("VisFFT1/scale").toInt();
			fullScope = QMPset->value("VisFFT1/fullScope").toBool();
			przesun = QMPset->value("VisFFT1/przesun").toInt();
			timRefValue = QMPset->value("VisFFT1/timRefValue").toInt();
			lpaski = QMPset->value("VisFFT1/lpaski").toInt();
			fftK = QMPset->value("VisFFT1/fftK").toBool();

			VisX = QMPset->value("VisFFT1/X").toInt();
			VisY = QMPset->value("VisFFT1/Y").toInt();
			VisW = QMPset->value("VisFFT1/W").toInt();
			VisH = QMPset->value("VisFFT1/H").toInt();

			if ( QMPset->value("VisFFT1/inDock").toBool() )
				Enabled = false;

			delete QMPset;

			if ( !IsPowerOfTwo(fftsize) )
				fftsize = fftDef;

			loaded = true;
		}
	}

	if ( !loaded )
	{
		isON = false;
		Enabled = false;
		okno = true;
		VisW = 400;
		VisH = 300;
		VisX = -1;
		VisY = -1;
		fftP = 1;
		fftL = 0;
		fftsize = fftDef;
		scale = 15;
		fullScope = 0;
		przesun = 2;
		timRefValue = 25;
		lpaski = 18;
		fftK = 1;
	}
}

void SAVE::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("VisFFT1/VisFFT1",true);

	QMPset->setValue("VisFFT1/Enabled",Enabled);
	QMPset->setValue("VisFFT1/isON",isON);
	QMPset->setValue("VisFFT1/okno",okno);
	QMPset->setValue("VisFFT1/fftP",fftP);
	QMPset->setValue("VisFFT1/fftL",fftL);
	QMPset->setValue("VisFFT1/fftsize",fftsize);
	QMPset->setValue("VisFFT1/scale",scale);
	QMPset->setValue("VisFFT1/fullScope",fullScope);
	QMPset->setValue("VisFFT1/przesun",przesun);
	QMPset->setValue("VisFFT1/timRefValue",timRefValue);
	QMPset->setValue("VisFFT1/lpaski",lpaski);
	QMPset->setValue("VisFFT1/fftK",fftK);

	QMPset->setValue("VisFFT1/X",VisX);
	QMPset->setValue("VisFFT1/Y",VisY);
	QMPset->setValue("VisFFT1/W",VisW);
	QMPset->setValue("VisFFT1/H",VisH);

	QMPset->setValue("VisFFT1/inDock",inDock);

	QMPset->sync();
	delete QMPset;
}
