void Save::odczytajopcje()
{
	bool loaded = false;
	if (QFile::exists( QMPConf ))
	{
		QMPset = new QSettings (QMPConf,QSettings::IniFormat);
		if ( QMPset->value("QMPOut/QMPOut").toBool() )
		{
			sL = QMPset->value("QMPOut/sL").toInt();
			sR = QMPset->value("QMPOut/sR").toInt();

			aL = QMPset->value("QMPOut/aL").toInt();
			aR = QMPset->value("QMPOut/aR").toInt();

			setOPlugVolume();

			bB = QMPset->value("QMPOut/bB").toBool();
			useAppVol = QMPset->value("QMPOut/useAppVol").toBool();
			visEff = QMPset->value("QMPOut/visEff").toBool();
			savEff = QMPset->value("QMPOut/savEff").toBool();
			toOplugS = QMPset->value("QMPOut/toOplugS").toBool();
			toOplugEx = QMPset->value("QMPOut/toOplugEx").toBool();
			chChnB = QMPset->value("QMPOut/chChnB").toBool();
			bEff = QMPset->value("QMPOut/bEff").toBool();
			zChnB = QMPset->value("QMPOut/zChnB").toBool();
			chChn2B = QMPset->value("QMPOut/chChn2B").toBool();
			titleE = QMPset->value("QMPOut/titleE").toBool();

			userBits = QMPset->value("QMPOut/userBits").toBool();
			userRate = QMPset->value("QMPOut/userRate").toBool();
			userChn = QMPset->value("QMPOut/userChn").toBool();
			UserBits = QMPset->value("QMPOut/_UserBits").toInt();
			UserRate = QMPset->value("QMPOut/_UserRate").toInt();
			UserChn = QMPset->value("QMPOut/_UserChn").toInt();

			silenceB = QMPset->value("QMPOut/silenceB").toBool();

			BufQ = QMPset->value("QMPOut/BufQ").toBool();
			QBuf = QMPset->value("QMPOut/QBuf").toInt();
			soundB = QMPset->value("QMPOut/soundB").toInt();

			buffQIfNeaded = QMPset->value("QMPOut/buffQIfNeaded").toBool();

			_priority = QMPset->value("QMPOut/_priority").toInt();

			titleB = QMPset->value("QMPOut/titleB").toBool();
			titleHB = QMPset->value("QMPOut/titleHB").toBool();

			delete QMPset;

			loaded = true;
		}
	}

	if ( !loaded )
	{
		sL = 100;
		sR = 100;
		setOPlugVolume();

		useAppVol = 1;
		visEff = true;
		savEff = 0;
		toOplugS = 1;
		toOplugEx = 0;
		bB = 1;
		chChnB = 0;
		bEff = 0;
		zChnB = 0;
		chChn2B = 0;
		titleE = 1;

		silenceB = 1;
		userBits = 1;
		userRate = 0;
		userChn = 0;
		UserBits = 16;
		UserRate = 44100;
		UserChn = 2;

		BufQ = true;
		QBuf = 16;
		soundB = 1;

		buffQIfNeaded = false;

		_priority = 1;

		titleB = 0;
		titleHB = 1;
	}
}

void Save::zapiszVol()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("QMPOut/QMPOut",true);

	QMPset->setValue("QMPOut/sL",sL);
	QMPset->setValue("QMPOut/sR",sR);

	QMPset->setValue("QMPOut/aL",aL);
	QMPset->setValue("QMPOut/aR",aR);

	QMPset->setValue("QMPOut/bB",bB);

	QMPset->sync();
	delete QMPset;
}

void Save::zapiszBb()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("QMPOut/bEff",bEff);

	QMPset->sync();
	delete QMPset;
}

void Save::zapiszopcje()
{
	QMPset = new QSettings (QMPConf,QSettings::IniFormat);

	QMPset->setValue("QMPOut/QMPOut",true);

	QMPset->setValue("QMPOut/bEff",bEff);

	QMPset->setValue("QMPOut/sL",sL);
	QMPset->setValue("QMPOut/sR",sR);

	QMPset->setValue("QMPOut/aL",aL);
	QMPset->setValue("QMPOut/aR",aR);

	QMPset->setValue("QMPOut/useAppVol",useAppVol);
	QMPset->setValue("QMPOut/visEff",visEff);
	QMPset->setValue("QMPOut/savEff",savEff);
	QMPset->setValue("QMPOut/toOplugS",toOplugS);
	QMPset->setValue("QMPOut/toOplugEx",toOplugEx);
	QMPset->setValue("QMPOut/chChnB",chChnB);
	QMPset->setValue("QMPOut/bEff",bEff);
	QMPset->setValue("QMPOut/zChnB",zChnB);
	QMPset->setValue("QMPOut/chChn2B",chChn2B);
	QMPset->setValue("QMPOut/titleE",titleE);

	QMPset->setValue("QMPOut/_priority",_priority);

	QMPset->setValue("QMPOut/userBits",userBits);
	QMPset->setValue("QMPOut/userRate",userRate);
	QMPset->setValue("QMPOut/userChn",userChn);
	QMPset->setValue("QMPOut/_UserBits",UserBits);
	QMPset->setValue("QMPOut/_UserRate",UserRate);
	QMPset->setValue("QMPOut/_UserChn",UserChn);

	QMPset->setValue("QMPOut/silenceB",silenceB);

	QMPset->setValue("QMPOut/BufQ",BufQ);
	QMPset->setValue("QMPOut/QBuf",QBuf);
	QMPset->setValue("QMPOut/soundB",soundB);
	QMPset->setValue("QMPOut/buffQIfNeaded",buffQIfNeaded);

	QMPset->setValue("QMPOut/titleB",titleB);
	QMPset->setValue("QMPOut/titleHB",titleHB);

	QMPset->sync();
	delete QMPset;
}
